// Для работы скрипта необходимо:
// - топор со Spell Channeling
// - дом с контейнером для отгрузки ресурсов на входе
// - рунбука с руной к дому (необходимо назвать 'home')
// - рунбуки с рунами к деревьям (необходимо назвать 'mspots')
// - лрк сет
// - магери
// Для настройки необходимо
// - указать путь к файлам игры для работы поиска деревьев
// - указать серийник топора axe_id, это можно сделать через вкладку World, найдя там свой топор в списке, либо через запуск клиента через стелс и командой info
// - указать серийник контейнера для ресурсов prod_container, это можно сделать через вкладку World, найдя там свой контейнер в списке, либо через запуск клиента через стелс и командой info
// - указать серийники дружественных персонажей на строчке 415, чтобы бот не пугался ваших персонажей
// - после запуска скрипта, бот потратит некоторое время на сканирование рунбук и начнет летать по рунам
Program RecallLumber;
const
prod_container = $40370F77;
axe_id = $40124B1F;
wait_minutes = 1;

home_book_name = 'home';
spots_book_name = 'mspots';

//gumps
book_gump = $554b87f3;

//misc
weight_threshold = 50;
SeekRange = 10;
spot_checks = 20;

//items
book_type = $22C5;

type
MinTile = record
x, y, z, Tile : Word;
end;

var
state:Byte;//0 - initial, 1 - harvest, 2 - unload/smelt
books: Array of Cardinal;
books_runes: Array of Integer;
home: Cardinal;
book: Integer;
rune: Integer;
SL : TStringList;
MinTiles_Array : Array of Array of Array of TFoundTile;
Resources, Trees: Array of Cardinal;
check, mine_index: Integer;
hidden: boolean;

walking: BOolean;
p : TPathArray;
target_x, target_y: Integer;
target: Cardinal;

function WaitForGump(id:Cardinal): Integer;
var
attempts, i: Integer;
begin
  for attempts := 0 to 15 do begin
    wait(200);
    for i := 0 to GetGUmpsCount - 1 do begin
      if GetGumpID(i) = id then begin
        Result := i;
        Exit;
      end;
    end;
  end;
  Result := -1;
  AddToSystemJournal('Гамп ' + IntTOStr(id) + ' не найден!');
end;


procedure ReplyGump(id, btn: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      if NumGumpButton(i, btn) then begin
        Wait(500);
        break;
      end;
    end;
  end;
end;

function HasProperty(item:Cardinal; prop: String):boolean;
var
tooltip:String;
i:Integer;
begin
  SL := TStringList.Create;
  tooltip := GetTooltip(item);

  StrBreakApart(tooltip, '|', SL);
  Result := false;
  for i := 0 to Sl.Count -1 do begin
    if(BMSearch(0, Sl.Strings[i], prop) <> 0) then begin
      Result := true;
      break;
    end;
  end;
  SL.Free;
end;

function GetRuneCount(id:Cardinal): Byte;
var
empty_amt, i, g_index:Integer;
gi: TGumpInfo;
begin
  Result := 16;
  UseObject(id);
  empty_amt := 0;
  g_index := WaitForGUmp(book_gump);
  if(g_index <> -1) then begin
    GetGumpInfo(g_index, gi);
    for i := Low(gi.CroppedText) to High(gi.CroppedText) do begin
      if(gi.CroppedText[i].Text_ID = 4) then begin
        empty_amt := empty_amt + 1;
      end;
    end;
    Result := 16 - round(empty_amt / 2);
    CloseSimpleGump(g_index);
  end;
end;

procedure NextRune;
begin
  AddToSystemJournal('Next Rune. Было: ' + IntToStr(rune) + '. В буке: ' + IntToStr(books_runes[book]));
  if((books_runes[book] <= rune + 1)) then begin
    AddToSystemJournal('Меняем книгу');

    rune := 0;
    if(book + 1 <= Length(books) - 1) then begin
      book := book + 1;
    end else begin
      book := 0;
    end;
  end else begin
    AddToSystemJournal('Следующая руна...');

    rune := rune + 1;
  end;
end;

procedure SetupBooks();
var
id: Cardinal;
List: TStringList;
i:Integer;
begin
  FIndType(book_type, Backpack);
  List := TStringList.Create;
  GetFindedList(List);
  for i := 0 to List.Count - 1 do begin
    id := StrToInt('$'+List[i]);
    if(HasProperty(id, spots_book_name)) then begin
      SetLength(books, Length(books) + 1);
      books[Length(books) - 1] := id;
      SetLength(books_runes, Length(books_runes) + 1);
      books_runes[Length(books_runes) - 1] := GetRuneCount(id);
      AddToSystemJournal('Рунбука ' + IntToStr(Length(books) - 1) + '. Рун: ' + IntTOStr(books_runes[Length(books_runes) - 1]));
      wait(1000);
    end;
    if(HasProperty(id, home_book_name)) then begin
      home := id;
      AddToSystemJournal('Книга домой наидена');
    end;
  end;
  if(home = -1) then begin
    AddToSystemJournal('Нет рунбуки домой!');
  end else begin
    AddToSystemJournal('Рунбука домой есть');
  end;
  if(Length(books) = 0) then begin
    AddToSystemJournal('Нет рунбук к кочкам!');
  end else begin
    AddToSystemJournal('Рунбук: ' + IntToStr(Length(books)));
  end;
  List.Free;
  SetLength(MinTiles_Array, Length(books_runes));
  for i := 0 to High(MinTiles_Array) do begin
    SetLength(MinTiles_Array[i], books_runes[i]);
  end;
end;

procedure Setup;
begin
  home := -1;
  book := 0;
  rune := 0;
  state := 0;
  check := 0;
  SetLength(books, 0);
  SetLength(books_runes, 0);
  SetupBooks();
end;

procedure CheckConnection;
begin
  if not Connected then begin
    while not Connected do begin
      AddToSystemJournal('Переподключение...');
      wait(10000);
      Connect;
    end;
    Setup;
  end;
end;

function Overloaded(): BOolean;
begin
  Result := (Weight > MaxWeight - weight_threshold);
end;

function MinTileSpot(Idx : Integer) : Integer;
var
i, k : Integer;
msgFizzle, msgEnd, msgAttack, msgSuccess : String;
cTime : TDateTime;

begin
  msgFizzle := 'hack at the tree ';
  msgEnd := 'not enough | seen';
  msgAttack := 'is attacking you';
  msgSuccess := 'chop some';

  result := 0;

  if Dist(GetX(self), GetY(self), MinTiles_Array[book][rune][Idx].X, MinTiles_Array[book][rune][Idx].Y) > 1 then
  NewMoveXY(MinTiles_Array[book][rune][Idx].X, MinTiles_Array[book][rune][Idx].Y, true, 1, true);

  for k := 0 to 7 do
  begin
    CheckConnection;

    if (ObjAtLayerEx(LhandLayer,self) = 0) then begin
      AddToSystemJournal('There is no axe equipped!');
      result := 1;
      exit;
    end;
    wait(400);

    UseObject(axe_id);


    if not WaitForTarget(5000) then
    begin
      AddToSystemJournal('There is no target for a long time (probably we lose an axe).');
      result := 1;
      exit;
    end
    else
    begin
      cTime := Now;
      TargetToTile(MinTiles_Array[book][rune][Idx].Tile, MinTiles_Array[book][rune][Idx].x, MinTiles_Array[book][rune][Idx].y, MinTiles_Array[book][rune][Idx].z);
      for i := 0 to 10 do
      begin
        CheckConnection;
        Wait(100);
        if (InJournalBetweenTimes(msgAttack, cTime, Now) <> -1) then begin result := 2; exit; end;
        if (InJournalBetweenTimes(msgEnd + '|far away', cTime, Now) <> -1) then  begin result := 3; exit; end;

        if (InJournalBetweenTimes(msgFizzle, cTime, Now) <> -1) then break;
        if (InJournalBetweenTimes(msgSuccess, cTime, Now) <> -1) then break;
        if ( Overloaded() ) then begin
          result := 2;
          exit;
        end;
      end;
    end;
  end;
end;

function isTree(id:Word):Boolean;
var
i:Integer;
begin
  for i := 0 to Length(Trees) -1 do begin
    if((Trees[i] - 16384) = id) then begin
      Result := true;
      Exit;
    end;
  end;
  Result := false;
end;

procedure GetTilesToMine;
var
x, y, i : Integer;
TileInfo : TFoundTile;
arr: TFoundTilesArray;
found: Word;
begin
  if(Length(MinTiles_Array[book][rune]) = 0) then begin

    SetLength(MinTiles_Array[book][rune], 0);
    for i := 0 to High(Trees) do begin
      found := GetStaticTilesArray(GetX(Self) + (-1 * SeekRange), GetY(Self) + (-1 * SeekRange), GetX(Self) + SeekRange, GetY(Self) + SeekRange, WorldNum, Trees[i], arr);
      if(found > 0) then begin
        for x := 0 to found do begin
          TileInfo := arr[x];
          if ((TileInfo.X > 0) and (TileInfo.Y > 0)) then
          begin
            SetLength(MinTiles_Array[book][rune], Length(MinTiles_Array[book][rune]) + 1);
            MinTiles_Array[book][rune][High(MinTiles_Array[book][rune])] := TileInfo;
          end;
        end;
      end;
    end;
    AddToSystemJournal('Found ' + IntToStr(Length(MinTiles_Array[book][rune])) + ' trees for lumber.');
    for i := 0 to High(MinTiles_Array[book][rune]) do begin
      AddToSystemJournal('- tree ' + IntToStr(MinTiles_Array[book][rune][i].x) + ' ' + IntToStr(MinTiles_Array[book][rune][i].y));
    end;
  end;
end;

function Recall(b:Cardinal; r: Integer; ByScroll: boolean):Byte;
var
x, y : Word;
i: Integer;
msgBlocked, msgRecharge, msgRecovered, msgYouMustWait, msgConcentration, msgOverWeigth, msgFAILS, msgALL: String;
cTime: TDateTime;
begin
  CheckConnection;

  msgRecharge      := 'This book needs time to recharge.';
  msgYouMustWait   := 'You must wait to perform another action.';
  msgBlocked       := 'That location is blocked.';
  msgRecovered     := 'You have not yet recovered from casting a spell.';
  msgConcentration := 'Your concentration is disturbed, thus ruining thy spell.';
  msgOverWeigth    := 'Thou art too encumbered to move.';
  msgFAILS := msgRecharge + '|' + msgYouMustWait + '|' + msgRecovered;
  AddToSystemJournal('Телепортация...');

  cTime := Now;
  UseObject(b);
  wait(1000);

  Step(1, true);
  WaitForGump(book_gump);

  x := GetX(SelfID);
  y := GetY(SelfID);
  ReplyGump(book_gump, 5 + (r * 6));
  wait(1000);
  for i := 0 to 6 do begin
    AddToSystemJournal('Проверка телепортации...');
    CheckConnection;
    wait(1000);
    if(InJournalBetweenTimes(msgFAILS, cTime, Now) <> -1) then begin result := 1; break; end;
    if(InJournalBetweenTimes(msgBlocked, cTime, Now) <> -1) then begin result := 2; break; end;

    if (((GetX(SelfID) <> x) or (GetY(SelfID) <> y))) then begin
      AddToSystemJournal('Телепорт удачный');
      Result := 0;
      Exit;
    end;
  end;
  AddToSystemJournal('Телепорт НЕудачный');
  result := 2;
end;

procedure Stop;
begin
end;


procedure TryTeleport;
var
st:Byte;
begin
  Wait(1000);
  st := Recall(books[book], rune, false);
  CheckConnection;
  if(st = 1 ) then begin
    TryTeleport;
    wait(1000);
  end else if (st = 2) then begin
    NextRune;
    TryTeleport;
    wait(1000);
  end else if (st = 0) then begin
    NextRune;
  end;
  state := 1;
end;



procedure RecallHome;
var
sucess: Byte;
begin
  AddToSystemJournal('Летим домой');
  state := 2;
  sucess :=  Recall(home, 0, false);
  while not (sucess = 0)
  do begin
    sucess :=  Recall(home, 0, false);
  end;
  CheckConnection;
end;


Function IsFriend(ID: Cardinal): Boolean;
Var
listFriends: array of Cardinal;
i: Integer;
Begin
  listFriends :=
[
  // ID друзей и своих персонажей:
  Self,
  $0003DDD0,
  $00059a74,
  $0007818C,
  $00017FC7,
  $00024331,
  $0000C2ED,
  $00233A2C,
  $00027F0E
  ];
  for i := 0 to Length(listFriends) - 1 do
  if ID = listFriends[i] then
  begin
    Result := TRUE;
    EXIT;
  end;
  Result := FALSE;
End;

function isMonster(body:Cardinal):boolean;
var
bodies: Array of Cardinal;
i:Integer;
begin
  bodies := [$0003, $0032, $001A, $0018, $0016, $0009,  $00A2, $0012,
  $0035, $0011, $001C,$0023,  $0004 , $003A, $0024 , $0001, $000D];
  Result := false;
  for i := 0 to High(bodies) do begin
    if(bodies[i] = body) then begin
      Result := true;
      Exit;
    end;
  end;
end;


Function CheckOfDangerNEW(ID: Cardinal): Boolean;
Var
ccRec: TClilocRec;
typeObject: Word;
i, k: Integer;
Begin
  Result := FALSE;
  if IsFriend(ID) then EXIT;
  k := 0;
  while (k < 10) and (GetTooltip(ID) = '') do
  begin
    k := k + 1;
    Wait(10);
  end;
  if GetTooltip(ID) <> '' then
  begin
    ccRec := GetToolTipRec(ID);
    for i := 0 to ccRec.Count - 1 do
    begin
      if ccRec.Items[i].ClilocID = 1060660 then
      begin
        typeObject := GetType(ID);
        AddToSystemJournal('ВНИМАНИЕ! Замечен подозрительный тип:');
        AddToSystemJournal('  Type: $' + IntToHex(typeObject, 4) +
        '  ID: $' + IntToHex(ID, 8) +
        '  Tooltip: ' + GetTooltip(ID));
        Result := TRUE;
        EXIT;
      end else if(isMonster(GetType(ID))) then begin
        AddToSystemJournal('ВНИМАНИЕ! Замечен монстр:');
        AddToSystemJournal('  Type: $' + IntToHex(typeObject, 4) +
        '  ID: $' + IntToHex(ID, 8) +
        '  Tooltip: ' + GetTooltip(ID));
        Result := FALSE;
        NextRune;
        TryTeleport;
        EXIT;
      end;
    end;
  end;
End;

procedure Evaquate;
begin
  hidden := true;
  Recall(home, 1, false);
  wait(1000);
  UseSkill('Hiding');
  DIsconnect;
  Wait(wait_minutes * 60 * 1000);
  CheckConnection;
  state := 0;
end;

Procedure EventDrawObject(ID: Cardinal);
Begin
  if CheckOfDangerNEW(ID) and not hidden then Evaquate;
End;

procedure TryHarvest;
var
MineResult: Integer;
begin
  CheckConnection;

  if(not Overloaded()) then begin
    GetTilesToMine;
    if(Length(MinTiles_Array[book][rune]) > 0) then begin
      if(check < spot_checks) then begin
        AddToSystemJournal('Пытаемся вырубить...');

        check := check + 1;
        if(mine_index + 1 < Length(MinTiles_Array[book][rune])) then begin
          mine_index := mine_index + 1;
        end else begin
          AddToSystemJournal('Летим дальше...');
          mine_index := 0;
          check := 0;
          TryTeleport;
          exit;
        end;
        CheckConnection;
        MineResult := MinTileSpot(mine_index);
        if MineResult = 1 then begin
          AddToSystemJournal('Нет топора!');

          RecallHome;
          state := 2;
          check := 0;
          exit;

        end;
        if MineResult = 2 then begin
          AddToSystemJournal('На нас напали!');

          RecallHome;
          state := 2;
          check := 0;
          exit;

        end;
        if MineResult = 3 then begin
          AddToSystemJournal('Нет дерева!');
          check := check + 1;
        end;
      end else begin
        AddToSystemJournal('Летим дальше...');

        mine_index := 0;
        check := 0;
        TryTeleport;
        exit;

      end;
    end else begin
      TryTeleport;
      check := 0;
      exit;

    end;
  end else begin
    AddToSystemJournal('Мы перегружены!!');
    RecallHome;
    state := 2;
    check := 0;
    exit;

  end;
end;


function HasResources():Boolean;
var
i:Integer;
begin
  for i := 0 to Length(Resources) -1 do begin
    if(FIndType(Resources[i], Backpack) <> 0) then begin
      Result := true;
      Exit
    end;
  end;
  Result := false;
end;

procedure TryConvert;
var
found:Cardinal;
i:Integer;
begin
  if(HasResources()) then begin
    for i := 0 to Length(Resources) -1 do begin
      if(FIndType(Resources[i], Backpack) <> 0) then begin
        found := finditem;
        break;
      end;
    end;
    MoveItem(found, findquantity, prod_container, 0,0,0);
    wait(1000);
  end else begin
    state := 0;
  end;
end;

begin
  SetEventProc(evDrawObject,'EventDrawObject');
  wait(5000);
  Resources := [$1BDD, $3190, $2f5f, $3191, $318f, $3199 ];
  Trees := [$CCA, $CCB, $CCC, $CCD, $CD0, $CD3, $CD6, $CD8,
  $CDA, $CDD, $CE0, $CE3, $CE6, $CF8, $CFB, $CFE,
  $D01, $D41, $D42, $D43, $D44, $D57, $D58, $D59,
  $D5A, $D5B, $D6E, $D6F, $D70, $D71, $D72, $D84,
  $D85, $D86, $12B5, $12B6, $12B7, $12B8, $12B9, $12BA,
  $12BB, $12BC, $12BD,

  $CCE, $CCF, $CD1, $CD2, $CD4, $CD5, $CD7, $CD9,
  $CDB, $CDC, $CDE, $CDF, $CE1, $CE2, $CE4, $CE5,
  $CE7, $CE8, $CF9, $CFA, $CFC, $CFD, $CFF, $D00,
  $D02, $D03, $D45, $D46, $D47, $D48, $D49, $D4A,
  $D4B, $D4C, $D4D, $D4E, $D4F, $D50, $D51, $D52,
  $D53, $D5C, $D5D, $D5E, $D5F, $D60, $D61, $D62,
  $D63, $D64, $D65, $D66, $D67, $D68, $D69, $D73,
  $D74, $D75, $D76, $D77, $D78, $D79, $D7A, $D7B,
  $D7C, $D7D, $D7E, $D7F, $D87, $D88, $D89, $D8A,
  $D8B, $D8C, $D8D, $D8E, $D8F, $D90, $D95, $D96,
  $D97, $D99, $D9A, $D9B, $D9D, $D9E, $D9F, $DA1,
  $DA2, $DA3, $DA5, $DA6, $DA7, $DA9, $DAA, $DAB,
  $12BE, $12BF, $12C0, $12C1, $12C2, $12C3, $12C4, $12C5,
  $12C6, $12C7];
  CheckConnection;
  Setup();
  while(true) do begin
    CheckConnection;
    case state of
      0:begin
        TryTeleport;
      end;
      1:begin
        TryHarvest;
      end;
      2:begin
        TryConvert;
      end;
    end;
    hidden := false;
  end;
end.