// Для работы скрипта необходимо:
// - тинкеринг, магери и майнинг
// - дом с контейнером для отгрузки ресурсов на входе
// - рунбука с руной к дому (необходимо назвать 'home')
// - рунбуки с рунами к спотам (необходимо назвать 'mspots')
// - лрк сет
// - тинкер тулс в контейнере для ресурсов и немного железа для крафта кирок и новых тинкер тулсов
// Для настройки необходимо
// - указать путь к файлам игры для работы поиска спотов
// - указать серийник контейнера для ресурсов prod_container, это можно сделать через вкладку World, найдя там свой контейнер в списке, либо через запуск клиента через стелс и командой info
// - указать серийники дружественных персонажей на строчке 545, чтобы бот не пугался ваших персонажей
// - после запуска скрипта, бот потратит некоторое время на сканирование рунбук и начнет летать по рунам
Program RecallMiner;
const
prod_container = $40370F77;

home_book_name = 'home';
spots_book_name = 'mspots';

wait_minutes = 1;

//gumps

book_gump = $554B87F3;
craft_gump = $38920abd;

//misc
weight_threshold = 50;
SeekRange = 10;
spot_checks = 10;

//items
Pickaxe = $0F39;
TinkerTools = $1EB8;
book_type = $22C5;
iron_ingots = $1BF2;
//colors
iron_color = 0;
copper_color = 2413;
gold_color = 2213;
dull_copper_color = 2419;
shadow_iron_color = 2406;
bronze_color = 2418;
agapite_color = 2425;
verite_color = 2207;
valorite_color = 2219;

type
MinTile = record
x, y, z, Tile : Word;
end;

var
state:Byte;//0 - initial, 1 - harvest, 2 - unload/smelt
books: Array of Cardinal;
books_runes: Array of Integer;
home, target: Cardinal;
book: Integer;
rune: Integer;
SL : TStringList;
i: Integer;
MinTiles_Array : Array of Array of Array of TFoundTile;
oldX, oldY:Integer;
Resources: Array of Cardinal;
Mines: Array of Cardinal;
check, mine_index: Integer;
hidden: Boolean;

procedure CloseGump(id: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      CloseSimpleGUmp(i);
      Wait(500);
      break;
    end;
  end;
end;

function WaitForGump(id:Cardinal): Integer;
var
attempts, i: Integer;
begin

  for attempts := 0 to 15 do begin
    AddToSystemJournal('Ждем гамп...');
    wait(200);
    for i := 0 to GetGUmpsCount - 1 do begin
      if GetGumpID(i) = id then begin
        Result := i;
        Exit;
      end;
    end;
  end;
  Result := -1;
  AddToSystemJournal('Гамп ' + IntTOStr(id) + ' не найден!');
end;


procedure ReplyGump(id, btn: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      if NumGumpButton(i, btn) then begin
        Wait(500);
        break;
      end;
    end;
  end;
end;

function HasProperty(item:Cardinal; prop: String):boolean;
var
tooltip: String;
i:Integer;
begin
  SL := TStringList.Create;
  tooltip := GetTooltip(item);

  StrBreakApart(tooltip, '|', SL);
  Result := false;
  for i := 0 to Sl.Count -1 do begin
    if(BMSearch(0, Sl.Strings[i], prop) <> 0) then begin
      Result := true;
      break;
    end;
  end;
  SL.Free;
end;

function GetRuneCount(id:Cardinal): Byte;
var
empty_amt, i, g_index:Integer;
gi: TGumpInfo;
begin
  Result := 16;
  UseObject(id);
  empty_amt := 0;
  g_index := WaitForGUmp(book_gump);
  if(g_index <> -1) then begin
    GetGumpInfo(g_index, gi);
    for i := Low(gi.CroppedText) to High(gi.CroppedText) do begin
      if(gi.CroppedText[i].Text_ID = 4) then begin
        empty_amt := empty_amt + 1;
      end;
    end;
    Result := 16 - round(empty_amt / 2);
    CloseSimpleGump(g_index);
  end;
end;

function isMineSpot(id:Cardinal):Boolean;
var
i:Integer;
begin
  for i := 0 to Length(Mines) -1 do begin
    if(Mines[i] = id) then begin
      Result := true;
      Exit;
    end;
  end;
  Result := false;
end;

procedure SetupBooks();
var
id: Cardinal;
List: TStringList;
i:Integer;
begin
  List := TStringList.Create;
  FIndType(book_type, Backpack);
  GetFIndedList(List);
  for i := 0 to List.Count - 1 do begin
    id := StrToInt('$'+List[i]);
    if(HasProperty(id, spots_book_name)) then begin
      SetLength(books, Length(books) + 1);
      books[Length(books) - 1] := id;
      SetLength(books_runes, Length(books_runes) + 1);
      books_runes[Length(books_runes) - 1] := GetRuneCount(id);
      wait(1000);
      AddToSystemJournal('Рунбука ' + IntToStr(Length(books) - 1) + '. Рун: ' + IntTOStr(books_runes[Length(books_runes) - 1]));

    end;
    if(HasProperty(id, home_book_name)) then begin
      home := id;
    end;
  end;
  if(home = -1) then begin
    AddToSystemJournal('Нет рунбуки домой!');
    EXIT;
  end else begin
    AddToSystemJournal('Рунбука домой есть');
  end;
  if(Length(books) = 0) then begin
    AddToSystemJournal('Нет рунбук к кочкам!');
    EXIT;
  end else begin
    AddToSystemJournal('Рунбук: ' + IntToStr(Length(books)));
  end;
  SetLength(MinTiles_Array, Length(books_runes));
  for i := 0 to High(MinTiles_Array) do begin
    SetLength(MinTiles_Array[i], books_runes[i]);
  end;
end;

procedure Setup;
begin
  home := -1;
  book := 0;
  rune := 0;
  state := 0;
  check := 0;
  SetLength(books, 0);
  SetLength(books_runes, 0);
  SetupBooks();
end;
                  
procedure CheckConnection;
begin
  if not Connected then begin
    while not Connected do begin
      AddToSystemJournal('Переподключение...');
      wait(10000);
      Connect;
    end;
    Cast('Protection');
    Setup;
  end;
end;
         
  procedure NextRune;
begin
CheckConnection;
  AddToSystemJournal('Next Rune. Было: ' + IntToStr(rune) + '. В буке: ' + IntToStr(books_runes[book]));
  if((books_runes[book] <= rune + 1)) then begin
    AddToSystemJournal('Меняем книгу');

    rune := 0;
    if(book + 1 <= Length(books) - 1) then begin
      book := book + 1;
    end else begin
      book := 0;
    end;
  end else begin
    AddToSystemJournal('Следующая руна...');

    rune := rune + 1;
  end;
end;

function Overloaded(): BOolean;
begin
  Result := (Weight > MaxWeight - weight_threshold);
end;

function HasPickaxe(): Boolean;
begin
  Result := (FindType(Pickaxe, Backpack) <> 0);
end;

function MinTileSpot(Idx : Integer) : Integer;
var
i, k : Integer;
msgFizzle, msgEnd, msgUseless, msgAttack, msgSuccess, notSeen, FarAway : String;
cTime : TDateTime;

begin
  msgFizzle := 'You put |You loosen |не получилось  ';
  msgEnd := 'no metal';
  FarAway := 'That is too far away.';
  notSeen :=   'Target cannot be seen.';
  msgAttack := ' is attacking you';
  msgSuccess := 'dig some';

  result := 0;
  if((Length(MinTiles_Array[book][rune]) > 0) and (Idx < (Length(MinTiles_Array[book][rune])))) then begin
    if Dist(GetX(self), GetY(self), MinTiles_Array[book][rune][Idx].X, MinTiles_Array[book][rune][Idx].Y) > 1 then
    NewMoveXY(MinTiles_Array[book][rune][Idx].X, MinTiles_Array[book][rune][Idx].Y, true, 1, true);

    for k := 0 to 7 do
    begin
      CheckConnection;
      wait(1000);

      if (ObjAtLayerEx(RhandLayer,self) = 0) then begin
        if FindType(Pickaxe, Backpack) = 0 then begin
          AddToSystemJournal('There are no pickaxes in a backpack.');
          result := 1;
          exit;
        end;
      end;

      UseType(Pickaxe, $FFFF);


      if not WaitForTarget(10000) then
      begin
        AddToSystemJournal('There is no target for a long time (probably we lose a pickaxe).');
        result := 1;
        exit;
      end
      else
      begin
        cTime := Now;
        TargetToXYZ(MinTiles_Array[book][rune][Idx].X, MinTiles_Array[book][rune][Idx].Y, MinTiles_Array[book][rune][Idx].Z);
        for i := 0 to 100 do
        begin
          CheckConnection;
          Wait(100);
          if (InJournalBetweenTimes(msgAttack, cTime, Now) <> -1) then begin result := 2; exit; end;
          if (InJournalBetweenTimes(msgEnd, cTime, Now) <> -1) then  begin result := 3; AddToSystemJournal('Кончился металл');exit; end;
          if (InJournalBetweenTimes(notSeen, cTime, Now) <> -1) then  begin result := 3;AddToSystemJournal('Не видно'); exit; end;
          if (InJournalBetweenTimes(FarAway, cTime, Now) <> -1) then  begin result := 3;AddToSystemJournal('Цель далеко'); exit; end;
          if (InJournalBetweenTimes(msgFizzle, cTime, Now) <> -1) then begin AddToSystemJournal('Не получилось выкопать');break; end;
          if (InJournalBetweenTimes(msgSuccess, cTime, Now) <> -1) then begin AddToSystemJournal('Удачно...'); break;  end;
          if ( Overloaded() ) then begin
            result := 2;
            AddToSystemJournal('Мы перегружены...');
            exit;
          end;
        end;
      end;
    end;
  end else begin
    result := 2;
  end;
end;

function  CanMine(x,y,z:Integer):Boolean;
var
i, noMine :Integer;
TileInfo : TMapCell;

begin
  Result := false;
  noMine := 0;
  for i := 0 to x + 1 do begin
    TileInfo := GetMapCell(GetX(self)+x + i - 1, GetY(self)+y-1, WorldNum);
    if(not isMineSpot(TileInfo.Tile)) then begin
      noMine := noMine + 1;
    end;
    TileInfo := GetMapCell(GetX(self)+x + i - 1, GetY(self)+y+1, WorldNum);
    if(not isMineSpot(TileInfo.Tile)) then begin
      noMine := noMine + 1;
    end;
  end;
  TileInfo := GetMapCell(GetX(self)+x - 1, GetY(self)+y, WorldNum);
  if(not isMineSpot(TileInfo.Tile)) then begin
    noMine := noMine + 1;
  end;
  TileInfo := GetMapCell(GetX(self)+x + 1, GetY(self)+y, WorldNum);
  if(not isMineSpot(TileInfo.Tile)) then begin
    noMine := noMine + 1;
  end;
  Result := (noMine > 0);
end;

procedure GetTilesToMine;
var
x, y, i : Integer;
TileInfo : TFoundTile;
arr: TFoundTilesArray;
found: Word;
begin
  if(Length(MinTiles_Array[book][rune]) = 0) then begin

    SetLength(MinTiles_Array[book][rune], 0);
    for i := 0 to High(Mines) do begin
      found := GetLandTilesArray(GetX(Self) + (-1 * SeekRange), GetY(Self) + (-1 * SeekRange), GetX(Self) + SeekRange, GetY(Self) + SeekRange, WorldNum, Mines[i], arr);
      if(found > 0) then begin
        for x := 0 to found do begin
          TileInfo := arr[x];
          if ((abs(TileInfo.Z - GetZ(Self)) < 3) and ((TileInfo.X > 0) and (TileInfo.Y > 0)){ and CanMine(TileInfo.X, TileInfo.Y, TileInfo.Z)}) then
          begin
            SetLength(MinTiles_Array[book][rune], Length(MinTiles_Array[book][rune]) + 1);
            MinTiles_Array[book][rune][High(MinTiles_Array[book][rune])] := TileInfo;
          end;
        end;
      end;
    end;
    { for x := (-1 * SeekRange) to SeekRange do
    for y := (-1 * SeekRange) to SeekRange do
    begin
    TileInfo := GetMapCell(GetX(self)+x, GetY(self)+y, WorldNum);
    if (isMineSpot(TileInfo.Tile) and (abs(TileInfo.z - GetZ(Self)) < 3) and CanMine(x, y, TileInfo.z)) then
    begin
    SetLength(MinTiles_Array[book][rune], Length(MinTiles_Array[book][rune]) + 1);
    MinTiles_Array[book][rune][High(MinTiles_Array[book][rune])].Tile := TileInfo.Tile;
    MinTiles_Array[book][rune][High(MinTiles_Array[book][rune])].x := GetX(self)+x;
    MinTiles_Array[book][rune][High(MinTiles_Array[book][rune])].y := GetY(self)+y;
    MinTiles_Array[book][rune][High(MinTiles_Array[book][rune])].z := TileInfo.z;
    end;
    end;
    end;}
    AddToSystemJournal('Found ' + IntToStr(Length(MinTiles_Array[book][rune])) + ' tiles for mining.');
    for i := 0 to High(MinTiles_Array[book][rune]) do begin
      AddToSystemJournal('- tile ' + IntToStr(MinTiles_Array[book][rune][i].x) + ' ' + IntToStr(MinTiles_Array[book][rune][i].y));
    end;
  end;
end;


function Recall(b:Cardinal; r: Integer; ByScroll: boolean):Byte;
var
x, y : Word;
i: Integer;
msgBlocked, msgRecharge, msgRecovered, msgYouMustWait, msgConcentration, msgOverWeigth, msgFAILS, msgALL: String;
cTime: TDateTime;
begin
  CheckConnection;

  msgRecharge      := 'This book needs time to recharge.';
  msgYouMustWait   := 'You must wait to perform another action.';
  msgBlocked       := 'That location is blocked.';
  msgRecovered     := 'You have not yet recovered from casting a spell.';
  msgConcentration := 'Your concentration is disturbed, thus ruining thy spell.';
  msgOverWeigth    := 'Thou art too encumbered to move.';
  msgFAILS := msgRecharge + '|' + msgYouMustWait + '|' + msgRecovered;
  AddToSystemJournal('Телепортация...');

  cTime := Now;
  UseObject(b);
  wait(1000);

  Step(1, true);
  WaitForGump(book_gump);

  x := GetX(SelfID);
  y := GetY(SelfID);
  wait(300);
  ReplyGump(book_gump, 5 + (r * 6));
  wait(1000);
  for i := 0 to 6 do begin
    AddToSystemJournal('Проверка телепортации...');
    CheckConnection;
    wait(1000);
    if(InJournalBetweenTimes(msgFAILS, cTime, Now) <> -1) then begin result := 1; break; end;
    if(InJournalBetweenTimes(msgBlocked, cTime, Now) <> -1) then begin result := 2; break; end;

    if (((GetX(SelfID) <> x) or (GetY(SelfID) <> y))) then begin
      AddToSystemJournal('Телепорт удачный');
      Result := 0;
      Exit;
    end;
  end;
  AddToSystemJournal('Телепорт НЕудачный');
  result := 2;
end;

procedure TryTeleport;
var
st:Byte;
begin
  st := Recall(books[book], rune, false);
  CheckConnection;
  if(st = 1 ) then begin
    TryTeleport;
    wait(1000);
  end else if (st = 2) then begin
    NextRune;
    TryTeleport;
    wait(1000);
  end else if (st = 0) then begin
    NextRune;
  end;
  state := 1;
end;


procedure RecallHome;
var
sucess: Byte;
begin
  AddToSystemJournal('Летим домой');
  state := 2;
  sucess :=  Recall(home, 0, false);
  while not (sucess = 0)
  do begin
    sucess :=  Recall(home, 0, false);
  end;
  CheckConnection;
end;

procedure TryHarvest;
var
MineResult: Integer;
begin
  CheckConnection;
  if(not Overloaded() and HasPickaxe()) then begin
    GetTilesToMine;
    if(Length(MinTiles_Array[book][rune]) > 0) then begin
      if(check < spot_checks) then begin
        check := check + 1;
        if(mine_index + 1 < Length(MinTiles_Array[book][rune])) then begin
          mine_index := mine_index + 1;
        end else begin
          mine_index := 0;
        end;
        CheckConnection;
        MineResult := MinTileSpot(mine_index);
        if MineResult = 1 then begin
          RecallHome;
          state := 2;
          check := 0;
          exit;
        end;
        if MineResult = 2 then begin
          RecallHome;
          state := 2;
          check := 0;
          exit;
        end;
      end else begin
        mine_index := 0;
        check := 0;
        TryTeleport;
        exit;
      end;
    end else begin
      TryTeleport;
      check := 0;
      exit;
    end;
  end else begin
    AddToSystemJournal('Мы перегружены или кончились лопаты!');
    RecallHome;
    state := 2;
    check := 0;
    exit;
  end;
end;

Function IsFriend(ID: Cardinal): Boolean;
Var
listFriends: array of Cardinal;
i: Integer;
Begin
  listFriends :=
[
  // ID друзей и своих персонажей:
  Self,
  $0003DDD0,
  $00059a74,
  $0007818C,
  $00017FC7,
  $00024331,
  $0000A768,
  $0000C2ED
  ];
  for i := 0 to Length(listFriends) - 1 do
  if ID = listFriends[i] then
  begin
    Result := TRUE;
    EXIT;
  end;
  Result := FALSE;
End;

function isMonster(body:Cardinal):boolean;
var
bodies: Array of Cardinal;
i:Integer;
begin
  bodies := [$0003, $0032, $001A, $0017, $0018, $0016, $0009,  $00A2, $0012,
  $0035, $0011, $001C,$0023,  $0004 , $003A, $0024 , $0001, $000D];
  Result := false;
  for i := 0 to High(bodies) do begin
    if(bodies[i] = body) then begin
      Result := true;
      Exit;
    end;
  end;
end;

Function CheckOfDangerNEW(ID: Cardinal): Boolean;
Var
ccRec: TClilocRec;
typeObject: Word;
i, k: Integer;
Begin
  Result := FALSE;
  if IsFriend(ID) then EXIT;
  k := 0;
  while (k < 10) and (GetTooltip(ID) = '') do
  begin
    k := k + 1;
    Wait(5);
  end;
  if GetTooltip(ID) <> '' then
  begin
    ccRec := GetToolTipRec(ID);
    for i := 0 to ccRec.Count - 1 do
    begin
      if ccRec.Items[i].ClilocID = 1060660 then
      begin
        typeObject := GetType(ID);
        AddToSystemJournal('ВНИМАНИЕ! Замечен подозрительный тип:');
        AddToSystemJournal('  Type: $' + IntToHex(typeObject, 4) +
        '  ID: $' + IntToHex(ID, 8) +
        '  Tooltip: ' + GetTooltip(ID));
        Result := TRUE;
        EXIT;
      end;{ else if(isMonster(GetType(ID))) then begin
      AddToSystemJournal('ВНИМАНИЕ! Замечен монстр:');
      AddToSystemJournal('  Type: $' + IntToHex(typeObject, 4) +
      '  ID: $' + IntToHex(ID, 8) +
      '  Tooltip: ' + GetTooltip(ID));
      NextRune;
      TryTeleport;
      Result := FALSE;
      EXIT;
      end;     }
    end;
  end;
End;

procedure Evaquate;
var
sucess:Byte;
begin
  hidden := true;
  sucess := Recall(home, 1, false);
  while not (sucess = 0)
  do begin
    sucess := Recall(home, 1, false);
  end;
  wait(1000);
  UseSkill('Hiding');
  DIsconnect;
  Wait(wait_minutes * 60 * 1000);
  CheckConnection;
  state := 0;
  RecallHome;
  hidden := false;
end;

Procedure EventDrawObject(ID: Cardinal);
Begin
  if CheckOfDangerNEW(ID) and not hidden then Evaquate;
End;

procedure CHeckIron;
begin
  FindTypeEx(iron_ingots, 0, Backpack, false);
  if(findfullquantity < 50) then begin
    UseObject(prod_container);
    wait(1000);
    FindTypeEx(iron_ingots, 0, prod_container, true);
    MoveItem(finditem, 50, Backpack, 1,1,1);
    wait(1000);
  end;
end;

procedure Craft(amt, btn1, btn2:Integer);
var
i:Integer;
begin
  CheckIron;
  FindType(TinkerTools, Backpack);
  for i := 0 to amt do begin
    CloseGump(craft_gump);
    wait(1000);
    UseObject(finditem);
    wait(1000);
    ReplyGump(craft_gump, btn1 );
    WaitForGump(craft_gump);
    ReplyGump(craft_gump, btn2);
    Wait(1000);
    CloseGump(craft_gump);
  end;
end;

procedure CheckTools;
begin
  if(FIndType(TinkerTools, Backpack) <> 0) then begin
    if(findfullquantity < 5) then begin
      Craft(1, 8, 23);
      wait(1000);
    end;
  end;
  while(FIndType(Pickaxe, Backpack) = 0) do begin
    Craft(1, 8, 72);
    wait(1000);
  end;
end;

function HasResources():Boolean;
var
i:Integer;
begin
  for i := 0 to Length(Resources) -1 do begin
    if(FIndType(Resources[i], Backpack) <> 0) then begin
      Result := true;
      Exit
    end;
  end;
  Result := false;
end;


procedure TryConvert;
var
found:Cardinal;
i:Integer;
begin
  CheckConnection;
  if(HasResources()) then begin
    for i := 0 to Length(Resources) -1 do begin
      CheckConnection;
      if(FIndType(Resources[i], Backpack) <> 0) then begin
        found := finditem;
        break;
      end;
    end;
    MoveItem(found, findquantity, prod_container, 0,0,0);
    wait(1000);
  end else begin
    CheckTools();
    state := 0;
  end;
end;

procedure evAttack(ID : Cardinal; Attack_OK : Boolean);
var
st: Byte;
begin
  AddToSystemJournal('ВНИМАНИЕ! Замечен монстр:');
  AddToSystemJournal(
  '  ID: $' + IntToHex(ID, 8) +
  '  Tooltip: ' + GetTooltip(ID));
  RecallHome;
end;

begin
  SetEventProc(evDrawObject,'EventDrawObject');
  SetEventProc(evAllow_RefuseAttack,'evAttack');
  wait(5000);
  Resources := [$3192, $19B7,$19B8,$19B9,$19BA,$3198,$3197,$3194,$3193, $3195, $f13, $f2d, $f25, $f15,
  $f16, $f17, $f18, $f19, $f20, $f21, $f0f, $f10, $f11, $f12, $f14, $f1a, $f1b, $f1c, $f1d,
  $f1e, $f1f, $f22, $f23, $f24, $f25, $f26, $f27, $f28, $f29, $f2A, $f2B, $f2C, $f2D, $f2E, $f2F, $F28];
  Mines := [220, 221, 222, 223, 224, 225, 226, 227, 228, 229,
  230, 231, 236, 237, 238, 239, 240, 241, 242, 243,
  244, 245, 246, 247, 252, 253, 254, 255, 256, 257,
  258, 259, 260, 261, 262, 263, 268, 269, 270, 271,
  272, 273, 274, 275, 276, 277, 278, 279, 286, 287,
  288, 289, 290, 291, 292, 293, 294, 296, 296, 297,
  321, 322, 323, 324, 467, 468, 469, 470, 471, 472,
  473, 474, 476, 477, 478, 479, 480, 481, 482, 483,
  484, 485, 486, 487, 492, 493, 494, 495, 543, 544,
  545, 546, 547, 548, 549, 550, 551, 552, 553, 554,
  555, 561, 562, 563, 564,
  565, 566, 567, 568, 569, 570, 571, 572, 573, 574,
  575, 576, 577, 578, 579, 581, 582, 583, 584, 585,
  586, 587, 588, 589, 590, 591, 592, 593, 594, 595,
  596, 597, 598, 599, 600, 601, 610, 611, 612, 613,

  1741, 1742, 1743, 1744, 1745, 1746, 1747, 1748, 1749,
  1750, 1751, 1752, 1753, 1771, 1772,
  1773, 1774, 1775, 1776, 1777, 1778, 1779, 1780, 1781, 1782,
  1783, 1784, 1785, 1786, 1801, 1802,
  1803, 1804, 1805, 1806, 1807, 1808, 1809, 1811, 1812, 1813,
  1814, 1815, 1816, 1817, 1818, 1819, 1820,
  1831, 1832, 1833, 1834, 1835, 1836, 1837, 1838, 1839,
  1840, 1841, 1842, 1843, 1844, 1845, 1846, 1847, 1848, 1849,
  1850, 1861, 1862, 1863, 1864, 1865,
  1866, 1867, 1868, 1869, 1870, 1871, 1872, 1873, 1874, 1875,
  1876, 1877, 1878, 1879, 1880, 1981,
  1982, 1983, 1984, 1985, 1986, 1987, 1988, 1989, 1990, 1991,
  1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000,
  $053B, $053C];
  CheckConnection;
  Setup();
  while true do begin
    wait(50);
    CheckConnection;
    case state of
      0:begin
        TryTeleport;
      end;
      1:begin
        TryHarvest;
      end;
      2:begin
        TryConvert;
      end;
    end;
  end;
end.